/*
    This program demonstrates several little ideas.

    You can access the entries of an array using either
    array notation or using pointers.

    Pointer arithmetic increments a pointer (i.e., an address)
    by an appropriate number of bytes and an integer takes up 4 bytes.

    You can print out the value of a pointer (i.e., an address) just
    like any other value.

    C does not stop you from going past the end of an array.

    printf() has very powerful formatting capabilities.

    And memory that has not been initialized contains garbage.
*/
#include <stdio.h>

int main()
{
   int myArray[] = {-3, -2, -1, 0, 1, 2, 3};
   int i;

   // Walk through the array using pointer arithmetic and
   // array notation. Print out the address of each number
   // in the array and the number. Notice how the addresses
   // increment.
   for (i = 0; i < 10; i++) // Go past the end of the array!
      printf("the number at address %p is %d\n",
              myArray+i, myArray[i]);

   // print a blank line
   printf("\n");

   // Walk through the array again but this time use only
   // pointers (and print the addresses in decimal and the
   // numbers in hexadecimal).
   for (i = 0; i < 10; i++) // Go past the end of the array!
      printf("the number at address %p is %#x\n",
              myArray+i, *(myArray+i));

   return 0;
}//main
